/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.utilities.KernelEditor;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.WindowConstants;
import javax.swing.table.DefaultTableModel;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.utilities.KernelEditor.KernelEditorShared.*;
import org.visnow.vn.lib.basic.utilities.KernelEditor.KernelEditorShared.KernelType;

/**
 *
 * @author Michal Lyczek (lyczek@icm.edu.pl)
 * @author Piotr Wendykier (piotrw@icm.edu.pl)
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    public GUI()
    {
        initComponents();
        presetCombo.setModel(new DefaultComboBoxModel(KernelType.values()));
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        final KernelType type = p.get(KERNEL_TYPE);
        final int rank = p.get(RANK);
        final int radius = p.get(RADIUS);
        final float sigma = p.get(GAUSSIAN_SIGMA);
        final boolean normalize = p.get(NORMALIZE_KERNEL);
        final float[] kernel = p.get(KERNEL);

        presetCombo.setSelectedItem(type);
        
        if (rank == 1) {
            jComboBox1.setSelectedIndex(0);
        } else if (rank == 2) {
            jComboBox1.setSelectedIndex(1);
        } else {
            jComboBox1.setSelectedIndex(2);
        }

        if (rSlider.getMax() < radius) rSlider.setMax(radius);
        if (rSlider.getMin() > radius) rSlider.setMin(radius);
        rSlider.setVal(radius);

        if (gaussianWidthSlider.getMax() < sigma) gaussianWidthSlider.setMax(sigma);
        if (gaussianWidthSlider.getMin() > sigma) gaussianWidthSlider.setMin(sigma);
        gaussianWidthSlider.setVal(sigma);
        normalizeCheckBox.setSelected(normalize);
        setTable(radius, rank, type, kernel);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        rSlider = new org.visnow.vn.gui.widgets.EnhancedIntSlider();
        normalizeCheckBox = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        presetCombo = new javax.swing.JComboBox();
        gaussianWidthSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        jLabel1.setText("Dimensions");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 5, 5, 5);
        add(jLabel1, gridBagConstraints);

        jComboBox1.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "1d", "2d", "3d" }));
        jComboBox1.setSelectedIndex(1);
        jComboBox1.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                jComboBox1ItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jComboBox1, gridBagConstraints);

        rSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Radius", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12))); // NOI18N
        rSlider.setMax(9);
        rSlider.setMin(1);
        rSlider.setVal(1);
        rSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                rSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(rSlider, gridBagConstraints);

        normalizeCheckBox.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        normalizeCheckBox.setText("Normalize");
        normalizeCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        normalizeCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        normalizeCheckBox.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                normalizeCheckBoxItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(normalizeCheckBox, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        jLabel5.setText("Preset masks");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 5, 5, 5);
        add(jLabel5, gridBagConstraints);

        presetCombo.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        presetCombo.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                presetComboItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(presetCombo, gridBagConstraints);

        gaussianWidthSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "gausian sigma", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 12))); // NOI18N
        gaussianWidthSlider.setEnabled(false);
        gaussianWidthSlider.setMax(2.0F);
        gaussianWidthSlider.setMin(0.5F);
        gaussianWidthSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                gaussianWidthSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipady = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(gaussianWidthSlider, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(10, 10));
        jScrollPane1.setViewportView(jTabbedPane1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipady = 200;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jScrollPane1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBox1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jComboBox1ItemStateChanged
        int rank = 2;
        switch (jComboBox1.getSelectedIndex()) {
            case 0:
                rank = 1;
                break;
            case 1:
                rank = 2;
                break;
            case 2:
                rank = 3;
                break;
        }
        if (rank != parameters.get(RANK)) {
            parameters.set(RANK, rank);
        }
    }//GEN-LAST:event_jComboBox1ItemStateChanged

    private void normalizeCheckBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_normalizeCheckBoxItemStateChanged
        if (parameters.get(KERNEL_TYPE) != KernelType.CUSTOM) {
            boolean normalized = parameters.get(NORMALIZE_KERNEL);
            if (normalized != normalizeCheckBox.isSelected()) {
                parameters.set(NORMALIZE_KERNEL, normalizeCheckBox.isSelected());
            }
        }
    }//GEN-LAST:event_normalizeCheckBoxItemStateChanged

    private void presetComboItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_presetComboItemStateChanged
        try {
            KernelType type = (KernelType)presetCombo.getSelectedItem();
            gaussianWidthSlider.setEnabled(type.equals(KernelType.GAUSSIAN));
            if (type != parameters.get(KERNEL_TYPE)) {
                parameters.set(KERNEL_TYPE, type);
            }
        } catch (ArrayIndexOutOfBoundsException ex) {
        }

    }//GEN-LAST:event_presetComboItemStateChanged

    private void gaussianWidthSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_gaussianWidthSliderStateChanged
        if (presetCombo.getSelectedIndex() == 1) {
            if (!gaussianWidthSlider.isAdjusting()) {
                float gaussianSigma = parameters.get(GAUSSIAN_SIGMA);
                if (gaussianSigma != gaussianWidthSlider.getVal()) {
                    parameters.set(GAUSSIAN_SIGMA, gaussianWidthSlider.getVal());
                }
            }
        }
    }//GEN-LAST:event_gaussianWidthSliderStateChanged

    private void rSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_rSliderStateChanged
    {//GEN-HEADEREND:event_rSliderStateChanged
        if (!rSlider.isAdjusting()) {
            int rxsize = rSlider.getVal();
            if (rxsize != parameters.get(RADIUS)) {
                parameters.set(RADIUS, rxsize);
            }
        }
    }//GEN-LAST:event_rSliderStateChanged

    private void setTable(int radius, int rank, KernelType type, float[] kernel)
    {
        try {
            jTabbedPane1.removeAll();

            int size = 2 * radius + 1;
            JTable[] tables;
            if (rank == 3) {
                tables = new JTable[size];
            } else {
                tables = new JTable[1];
            }

            if (rank == 3) {
                for (int z = 0; z < size; z++) {
                    tables[z] = new JTable();
                    DefaultTableModel defaultModel = new DefaultTableModel(size, size);

                    tables[z].setModel(defaultModel);
                    tables[z].setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                    for (int i = 0; i < tables[z].getColumnModel().getColumnCount(); i++) {
                        tables[z].getColumnModel().getColumn(i).setPreferredWidth(40);
                    }
                    for (int y = 0; y < size; y++) {
                        for (int x = 0; x < size; x++) {
                            float elem = kernel[z * size * size + y * size + x];
                            tables[z].setValueAt(String.format("%4.2f", elem), y, x);
                        }
                    }
                    if (type == KernelType.CUSTOM) {
                        tables[z].setEnabled(true);
                        tables[z].addKeyListener(new MyKeyListener());
                    } else {
                        tables[z].setEnabled(false);
                    }
                    jTabbedPane1.addTab("" + z, tables[z]);
                }
            } else if (rank == 2) {
                tables[0] = new JTable();
                DefaultTableModel defaultModel = new DefaultTableModel(size, size);
                tables[0].setModel(defaultModel);
                tables[0].setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                for (int i = 0; i < tables[0].getColumnModel().getColumnCount(); i++) {
                    tables[0].getColumnModel().getColumn(i).setPreferredWidth(40);
                }
                for (int y = 0; y < size; y++) {
                    for (int x = 0; x < size; x++) {
                        float elem = kernel[y * size + x];
                        tables[0].setValueAt(String.format("%4.2f", elem), y, x);
                    }
                }
                if (type == KernelType.CUSTOM) {
                    tables[0].setEnabled(true);
                    tables[0].addKeyListener(new MyKeyListener());
                } else {
                    tables[0].setEnabled(false);
                }
                jTabbedPane1.addTab("0", tables[0]);
            } else if (rank == 1) {
                tables[0] = new JTable();
                DefaultTableModel defaultModel = new DefaultTableModel(1, size);
                tables[0].setModel(defaultModel);
                tables[0].setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                for (int i = 0; i < tables[0].getColumnModel().getColumnCount(); i++) {
                    tables[0].getColumnModel().getColumn(i).setPreferredWidth(40);
                }
                for (int x = 0; x < size; x++) {
                    float elem = kernel[x];
                    tables[0].setValueAt(String.format("%4.2f", elem), 0, x);
                }
                if (type == KernelType.CUSTOM) {
                    tables[0].setEnabled(true);
                    tables[0].addKeyListener(new MyKeyListener());
                } else {
                    tables[0].setEnabled(false);
                }
                jTabbedPane1.addTab("0", tables[0]);
            }
        } catch (ArrayIndexOutOfBoundsException a) {
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.gui.widgets.FloatSlider gaussianWidthSlider;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JCheckBox normalizeCheckBox;
    private javax.swing.JComboBox presetCombo;
    private org.visnow.vn.gui.widgets.EnhancedIntSlider rSlider;
    // End of variables declaration//GEN-END:variables
    private void updateKernel()
    {
        try {
            if (parameters.get(KERNEL_TYPE) == KernelType.CUSTOM) {
                int size = 2 * parameters.get(RADIUS) + 1;
                float[] data = parameters.get(KERNEL);
                int rank = parameters.get(RANK);
                int i = 0;
                if (rank == 3) {
                    for (int z = 0; z < size; z++) {
                        for (int y = 0; y < size; y++) {
                            for (int x = 0; x < size; x++, i++) {
                                data[i] = Float.valueOf((String) ((JTable) jTabbedPane1.getComponentAt(z)).getValueAt(y, x));

                            }

                        }
                    }
                } else if (rank == 2) {
                    for (int y = 0; y < size; y++) {
                        for (int x = 0; x < size; x++, i++) {
                            data[i] = Float.valueOf((String) ((JTable) jTabbedPane1.getComponentAt(0)).getValueAt(y, x));

                        }
                    }
                } else if (rank == 1) {
                    for (int x = 0; x < size; x++, i++) {
                        data[i] = Float.valueOf((String) ((JTable) jTabbedPane1.getComponentAt(0)).getValueAt(0, x));

                    }
                }
                parameters.set(KERNEL, data);
            }
        } catch (ArrayIndexOutOfBoundsException a) {
        }
    }

    class MyKeyListener implements KeyListener
    {

        @Override
        public void keyPressed(KeyEvent e)
        {
        }

        @Override
        public void keyReleased(KeyEvent e)
        {
            if (e.getKeyCode() == 10) {
                updateKernel();
            }
        }

        @Override
        public void keyTyped(KeyEvent e)
        {
        }
    }

    public static void main(String[] args)
    {
        JFrame f = new JFrame();
        f.add(new GUI());
        f.pack();
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        f.setVisible(true);
    }

}
